#ifndef GRADIENTDESCENT_H
#define GRADIENTDESCENT_H
# include "problem.h"

class GradientDescent
{
protected:
    double rate;
    Data xpoint;
    double ypoint;
    Problem *myProblem;
public:
    /**
     * @brief GradientDescent, methodos dimioyrgias. Orizei to problima
     * pros beltistopoihsh.
     * @param p
     */
    GradientDescent(Problem *p);
    /**
     * @brief setRate, orizei ton rythmo mathisis.
     * @param r
     */
    void setRate(double r);
    /**
     * @brief getRate, epistrefei ton rythmo mathisis
     * @return
     */
    double getRate() const;

    /**
     * @brief updateRate, methodos enimerosis rate.
     */
    virtual void    updateRate();

    /**
     * @brief updatePoint, methodos  enimerosis best point
     */
    virtual void    updatePoint();

    /**
     * @brief Solve, i synoliki methodos gradient descent
     */
    void    Solve();

    /**
     * @brief getbestx, epistrefei to kalytero simeio pou exei brethei apo tin
     * gradient descent
     * @return
     */
    Data    getbestx();
    ~GradientDescent();
};
#endif // GRADIENTDESCENT_H
